#include "dxEffectIncludes.h"


typedef struct
{
	float red;
	float green;
	float blue;
} fxVars;

cbuffer variableBuffer : register(b2)
{
	fxVars vars;
}

fxVertexOut vertexShader(fxShaderVerts input)
{
	fxVertexOut output;
	output.position =float4(input.position,1);
	output.tex1 = input.tex1;
	output.texMask = input.texMask;
	return output;
}


float4 pixelShader(fxVertexOut input) : SV_TARGET
{
	vec4 texColor = tex(inputTex, fsTexture);
	float4 outColor=texColor*vec4(vars.red,vars.green,vars.blue,1.0);

	float blendValue=u.blendValue;
#ifdef USE_MASK
	blendValue*=tex(inputTexMask,input.texMask).a;
#endif
	outColor.rgb=mix(texColor.rgb,outColor.rgb,blendValue);
	return outColor;
}
