Texture2D  inputTex : register(t0);

SamplerState linearSampler : register(s0);

// data structure : before vertex shader (mesh info)
struct vertexInfo
{
	float3 position : POSITION;
	float2 uv: TEXCOORD0;
};

// data structure : vertex shader to pixel shader
// also called interpolants because values interpolates through the triangle
// from one vertex to another
struct v2p
{
	float4 position : SV_POSITION;
	float2 texCoord0 : TEXCOORD0;
	float2 texCoord1 : TEXCOORD1;
	float2 texCoord2 : TEXCOORD2;
	float2 texCoord3 : TEXCOORD3;
};

static const float2 s1 = float2(-.5, .5);
static const float2 s2 = float2( .5, .5);
static const float2 s3 = float2( .5,-.5);
static const float2 s4 = float2(-.5,-.5);


v2p vertexShader(vertexInfo input)
{
	v2p output;
	output.position = float4(input.position,1.0);
	output.position.y*=-1;
	output.texCoord0 = input.uv;
	return output;
}


float4 pixelShader(v2p input) : SV_TARGET
{
	float width,height;
	inputTex.GetDimensions(width,height);

	float2 texSize=float2(width,height);

	float4 outColor=inputTex.Sample(linearSampler,input.texCoord0/texSize);
	return outColor;
}

