#define vec2 float2
#define vec4 float4
#define mix(a,b,c) lerp(a,b,c)
#define fract frac

SamplerState linearSampler : register(s0);
SamplerState nearestSampler : register(s0);


#define textureFetchNearest(a,b) a.Sample(nearestSampler,b)
#define fsTexture input.tex1
#define tex(a,b) a.Sample(linearSampler,b)

Texture2D  inputTex : register(t0);
Texture2D  inputTexMask : register(t1);

typedef struct
{
	float3 position: POSITION;
	float2 tex1: TEXCOORD0;
	float2 texMask: TEXCOORD1;
} fxShaderVerts;

typedef struct
{
	float4 position: SV_POSITION;
	float2 tex1: TEXCOORD0;
	float2 texMask: TEXCOORD2;
} fxVertexOut;

struct fxGeneralUniforms
{
	int renderPass;
	float globalTime;
	float localTime;
	float random;
	float randomOnce;
	float blendValue;
	float pad0;
	float pad1;
} ;

cbuffer transitionBuffer : register(b1)
{
	fxGeneralUniforms u;
}
