

#include "dxShaderIncludes.h"


float rand (vec2 co)
{
	return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float Gaussian(float p, float center, float c)
{
	return 0.575 * exp(- pow((p - center) / c, 2.));
}


vertexOut vertexShader(txShaderVerts input)
{
	vertexOut output;
	output.position = mul(u.worldViewProj,float4(input.position,1));
	output.tex1 = input.tex1;
	output.tex2 = input.tex2;
	output.texMask = input.texMask;
	return output;
}


float4 pixelShader(vertexOut input) : SV_TARGET
{
	vec2 p = input.tex1;
	vec2 p2 = input.tex2;

	float c = cos(Gaussian(u.transitionProgressLinear * (1. + Gaussian(u.transitionProgressLinear * rand(p), 0.5, 0.5)), 0.5, 0.5));
	float c2 = cos(Gaussian(u.transitionProgressLinear * (1. + Gaussian(u.transitionProgressLinear * rand(p2), 0.5, 0.5)), 0.5, 0.5));
	vec2 d = p * c;
	vec2 d2 = p2 * c2;

	vec4 colorA=tex(inputTex0,d);
	vec4 colorB=tex(inputTex1,d2);
	float4 outColor=mix(colorB,colorA,u.transitionProgressLinear);

	#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,input.texMask).a);
	#endif


	return outColor;
}
